<?php

/* public */ class plugin_db_admin extends plugin {

  /* private secureFileStream */ var $file;

  /* constructor */ function plugin_db_admin($name)
  {
    settype($name,"string");
    $this->name = $name;
    global $YANA;
    $this->file = $YANA->plugins->get($this->name,"DBCONFIGFILE");
  }

  function get_db_configuration($ARGS)
  {
      settype($ARGS, "array");
      global $YANA;

      if (!class_exists("DB")) {
        $YANA->report( new error('PEARDB_FAILURE') );
        return false;
      }

      $YANA->setVar("DATABASE_DBMS",     YANA_DATABASE_DBMS);
      $YANA->setVar("DATABASE_HOST",     YANA_DATABASE_HOST);
      $YANA->setVar("DATABASE_PORT",     YANA_DATABASE_PORT);
      $YANA->setVar("DATABASE_USER",     YANA_DATABASE_USER);
      $YANA->setVar("DATABASE_PASSWORD", YANA_DATABASE_PASSWORD);
      $YANA->setVar("DATABASE_PREFIX",   YANA_DATABASE_PREFIX);
      $YANA->setVar("DATABASE_NAME",     YANA_DATABASE_NAME);
      return true;
  }

  function set_db_configuration($ARGS)
  {
      settype($ARGS, "array");
      global $YANA;

      /* check input data */
      $test = dbServer::test($ARGS['database_dbms'],$ARGS['database_host'],$ARGS['database_user'],$ARGS['database_password'],$ARGS['database_port'],$ARGS['database_name']);
      if ($test !== true) return false;

      $text = "<?php

if (!defined('YANA_DATABASE_DBMS'))     define('YANA_DATABASE_DBMS', '".    ( (isset($ARGS['database_dbms']))     ? $ARGS['database_dbms']     : YANA_DATABASE_DBMS )     ."');
if (!defined('YANA_DATABASE_HOST'))     define('YANA_DATABASE_HOST', '".    ( (isset($ARGS['database_host']))     ? $ARGS['database_host']     : YANA_DATABASE_HOST )     ."');
if (!defined('YANA_DATABASE_PORT'))     define('YANA_DATABASE_PORT','".     ( (isset($ARGS['database_port']))     ? $ARGS['database_port']     : YANA_DATABASE_PORT )     ."');
if (!defined('YANA_DATABASE_USER'))     define('YANA_DATABASE_USER','".     ( (isset($ARGS['database_user']))     ? $ARGS['database_user']     : YANA_DATABASE_USER )     ."');
if (!defined('YANA_DATABASE_PASSWORD')) define('YANA_DATABASE_PASSWORD','". ( (isset($ARGS['database_password'])) ? $ARGS['database_password'] : YANA_DATABASE_PASSWORD ) ."');
if (!defined('YANA_DATABASE_PREFIX'))   define('YANA_DATABASE_PREFIX','".   ( (isset($ARGS['database_prefix']))   ? $ARGS['database_prefix']   : YANA_DATABASE_PREFIX )   ."');
if (!defined('YANA_DATABASE_NAME'))     define('YANA_DATABASE_NAME','".     ( (isset($ARGS['database_name']))     ? $ARGS['database_name']     : YANA_DATABASE_NAME )     ."');

?>";
      if (!$this->file->exists()) $this->file->create();
      $this->file->read();
      $this->file->remove();
      $this->file->insert($text);
      $this->file->failSafeWrite();
      return true;
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
