<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

/* public */ class plugin_default_library extends plugin {

  /* public void */ function _default(/* String */ $event, /* Hashtable */ $ARGS) {
    settype($event, "string");
    settype($ARGS, "array");
    $event = strtolower($event);

    global $YANA;

    # <... Besucherzhler
    if (!empty($ARGS['id'])) {
      $my_counter = new counter();
      $YANA->setVar('BESUCHER', $my_counter->count($ARGS['id']));
    }
    # ...>

    return true;
  }
  
  /* public boolean */ function sitemap (/* Hashtable */ $ARGS) {
    global $YANA;
    if (!empty($ARGS['id'])) {
      $my_counter = new counter();
      $YANA->setVar('BESUCHER', $my_counter->count($ARGS['id']));
    } else {
      $my_counter = new counter();
      $YANA->setVar('BESUCHER', $my_counter->count('default'));
    }
    $YANA->setVar("PROFILES", $YANA->plugins->getPluginList());
    return true;
  }

  /* public boolean */ function clear_server_cache (/* Hashtable */ $ARGS) {
    global $YANA;
    smartTemplate::clearCache();

    if (!empty($ARGS['target']))
    {
      $YANA->message("OK", "200", $ARGS['target']);
    }
    return true;
  }

  /* public boolean */ function preview (/* Hashtable */ $ARGS) {
    global $YANA;
    if (!isset($ARGS['eintraege'])) die('<h1>ERROR 500:</h1><p>Erforderlicher Parameter &quot;eintraege&quot; nicht gesetzt.</p>');
    $blank = $YANA->registry->get("blank");
    $blankDoc = new smartTemplate($blank->getFilename());
    $blankDoc->insert('*',$YANA->getVar("*"));
    $blankDoc->insert('*','<div style="height: 100%; overflow: auto;">'.nl2br(embeddedTags(addSmilies(toHtmlEntities(stripslashes($ARGS['eintraege']))))).'</div>');
    die($blankDoc->get());
  }

  /* public boolean */ function security_get_image (/* Hashtable */ $ARGS) {
    global $YANA;
    header("Content-type: image/png");

    $imagesrc = $YANA->getVar("CONFIGDIR")."security_image/security_image.png";
    $file     = new datfile($YANA->getVar("CONFIGDIR")."security_image/security_image.dat");

    if (!$file->exists()) {
      $file->create();
    }
    $file->read();
    if (!$file->isEmpty()) $contents = $file->get(0);
    else                   $contents = array();

    if (!isset($contents['TIME']) || $contents['TIME'] < time() || $contents['MAX_TIME'] < time())
    {
      $contents = array();
      $contents['MAX_TIME'] = time() + 10000;
      for ($i=1;$i<10;$i++)
      {
        $contents["_$i"] = "";
        for ($j=0;$j<5;$j++)
        {
          switch (rand(0,2)) {
            case 0:
              $contents["_$i"] .= chr(rand(65,90));
            break;
            case 1:
              $contents["_$i"] .= chr(rand(48,57));
            break;
            case 2:
              $contents["_$i"] .= chr(rand(97,122));
            break;
          }
        }
      }
    }
    $contents['TIME'] = time() + 1800;
    $file->remove(0);
    $file->insert($contents);
    $file->write();

    if (!isset($ARGS['security_image_index']) || $ARGS['security_image_index'] < 1 || $ARGS['security_image_index'] > 9)
    $text =& $contents['_1'];
    else
    $text =& $contents['_'.$ARGS['security_image_index']];

    $myImage = imagecreatefrompng($imagesrc);
    $white   = imageColorAllocate($myImage,255,255,255);
    $color   = imageColorAllocate($myImage,40,40,40);
    imagestring($myImage,5,4,1,$text,$color);
    imagepng($myImage);
    imagedestroy($myImage);
    die();
  }

  /* public boolean */ function security_check_image (/* Hashtable */ $ARGS) {
    global $YANA;
    $file = new datfile($YANA->getVar("CONFIGDIR")."security_image/security_image.dat");
    $file->read();
    if (!$file->isEmpty()) $contents = $file->get(0);
    else                   $contents = array();

    if ($contents['MAX_TIME'] < time()) return false;

    if (!isset($ARGS['security_image_index']) || $ARGS['security_image_index'] < 1 || $ARGS['security_image_index'] > 9)
    $text =& $contents['_1'];
    else
    $text =& $contents['_'.$ARGS['security_image_index']];
    return !empty($text) && ($ARGS['security_image'] == $text);
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
