<?php

/* public */ class plugin_guestbook extends plugin {

  /* private guestbook */ var $guestbook;
  /* private readonly String */ var $ACTION_SHOW          = "show";
  /* private readonly String */ var $ACTION_DETAILS       = "details";
  /* private readonly String */ var $ACTION_NEW           = "new";
  /* private readonly String */ var $ACTION_NEW_WRITE     = "add";
  /* private readonly String */ var $ACTION_DELETE        = "deleteentry";
  /* private readonly String */ var $ACTION_COMMENT       = "comment";
  /* private readonly String */ var $ACTION_COMMENT_WRITE = "addcomment";

  /* constructor */ function plugin_guestbook($name) {
      settype($name,"string");
      global $YANA, $lcn_note;

      $this->name = $name;
      $YANA->setVar("ACTION_SHOW"         , $this->ACTION_SHOW);
      $YANA->setVar("ACTION_DETAILS"      , $this->ACTION_DETAILS);
      $YANA->setVar("ACTION_NEW"          , $this->ACTION_NEW);
      $YANA->setVar("ACTION_NEW_WRITE"    , $this->ACTION_NEW_WRITE);
      $YANA->setVar("ACTION_DELETE"       , $this->ACTION_DELETE);
      $YANA->setVar("ACTION_COMMENT"      , $this->ACTION_COMMENT);
      $YANA->setVar("ACTION_COMMENT_WRITE", $this->ACTION_COMMENT_WRITE);


      # <... Umgebungsvariablen initialisieren
          $YANA->registry->settype("PROFILE.GUESTBOOK.NOTIFICATION", "boolean");
          $YANA->registry->settype("PROFILE.GUESTBOOK.SENDMAIL"    , "boolean");
          $YANA->registry->settype("PROFILE.AUTO"                  , "boolean");

          $url = $YANA->getVar("SETTINGS.CSS");
      	  if ($url) $YANA->setVar("CSS", '<link rel="stylesheet" type="text/css" href="'.$url.'">');

          $perm = $YANA->getVar("PERMISSION");
      	  if (!$perm) {
             $YANA->setVar("PERMISSION", isset($_SESSION['user_name']));
          }

/*          if (!$YANA->getVar("LICENCE.KEY")) {
              $YANA->setVar("LICENCE.INFO", "keine Lizenzdatei installiert");
          } else {
              $lcn_note = layout::fillTemplate($lcn_note, $YANA->getVar("LICENCE"), false);
          }*/
          $YANA->language->read("guestbook");
          $dir = $YANA->getVar("PROFILE.SMILEYDIR");
          if (is_dir($dir)) loadSmilies($dir);
      # Umgebungsvariablen initialisieren ...>
  }

  /* public void */ function _default(/* String */ $event, /* Hashtable */ $ARGS) {
     settype($event, "string");
     settype($ARGS, "array");
     $event = strtolower($event);

     $this->guestbook = new guestbook($ARGS);

     switch ($event) {

        case "":
          $this->guestbook->getBookEntries(false);
        break;

        case $this->ACTION_SHOW:
          $this->guestbook->getBookEntries(false);
        break;

        case $this->ACTION_DETAILS:
          $this->guestbook->getBookEntries(true);
        break;

        case $this->ACTION_NEW:
          $this->guestbook->get_new();
        break;

        case $this->ACTION_COMMENT:
          $this->guestbook->get_comment();
        break;

        case "delete":
          $this->guestbook->get_delete();
        break;

        case $this->ACTION_DELETE:
          return $this->guestbook->set_delete();
        break;

        case $this->ACTION_COMMENT_WRITE:
          $this->guestbook->set_comment($ARGS['guestbook_comment']);
        break;

        case $this->ACTION_NEW_WRITE:
          return $this->guestbook->set_new($ARGS);
        break;

        default:
        break;

     } # end switch

     return true;

  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
